MyBankApp/Controllers/PurchaseController.cs
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using MyBankApp.Core.Services.Contracts;
using MyBankApp.Core.ViewModels;

namespace MyBankApp.Controllers
{
    //[Authorize(Roles = "PremiumUser, Administrator")]
    public class PurchaseController : BaseController
    {
        private readonly IPurchaseService service;
        private readonly IAccountService accountService;
        private readonly IHttpContextAccessor context;
        private readonly IInitialPageService initialPageService;

        public PurchaseController(IPurchaseService service, IAccountService accountService, IHttpContextAccessor context, IInitialPageService initialPageService)
        {
            this.service = service;
            this.accountService = accountService;
            this.context = context;
            this.initialPageService = initialPageService;
        }

        public IActionResult SelectAccount(string name, decimal price)
        {
            ViewBag.Name = name;
            ViewBag.Price = price;

            var userName = context.HttpContext.User.Identity.Name;

            var model = accountService.GetAll(userName);
            return View(model);
        }


        public IActionResult Currency(string name, decimal price, string AccountId)
        {
            ViewBag.AccountId = AccountId;

            var model = service.BuyCurrencyView(name, price);

            return View(model);
        }

        [HttpPost]
        public async Task<IActionResult> BuyCurrency(BuyCurrencyInputModel model)
        {
            if (!ModelState.IsValid)
            {
                
            }
            await service.BuyCurrency(model);
            return RedirectToAction("BoughtCurrencies");
        }

        public async Task<IActionResult> BoughtCurrencies()
        {
            var latestCurrencyValues = await initialPageService.GetCurrencyData();

            var model = await service.BoughtCurrencies(latestCurrencyValues);
            return View(model);
        }

        public async Task<IActionResult> Sell(string name, decimal amount)
        {
            var latestCurrencyValues = await initialPageService.GetCurrencyData();

            var model = await service.SellCurrencyView(name, amount, latestCurrencyValues);
            return View(model);
        }

        [HttpPost]
        public async Task<IActionResult> Sell(SellCurrencyInputModel model)
        {
            try
            {
                var userName = context.HttpContext.User.Identity.Name;
                await service.SellCurrency(model, userName);
                return RedirectToAction(nameof(BoughtCurrencies));
            }
            catch (ArgumentNullException ex)
            {
                ViewBag.Error = ex.Message;

                return View("Error");
            }
        }
    }
}

MyBankApp/Controllers/TransactionController.cs
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using MyBankApp.Core.Services.Contracts;
using MyBankApp.Core.ViewModels;

namespace MyBankApp.Controllers
{
    public class TransactionController : BaseController
    {
        private readonly ITransactionService service;
        private readonly IHttpContextAccessor context;

        public TransactionController(ITransactionService service, IHttpContextAccessor context)
        {
            this.service = service;
            this.context = context;
        }

        public async Task<IActionResult> VerifySendingSum(string sum, string senderAccountId, TransactionInputModel model)
        {
            var res = service.CheckBalance(sum, senderAccountId);
            if (sum == null || model.Description == null)
            {
                return await Create(model);
            }

            if (res.Balance < decimal.Parse(sum))
            {
                return StatusCode(600);
            }
            else
            {
                return await Create(model);
            }
        }

        [HttpPost]
        public JsonResult Autocomplete(string prefix)
        {
            var users = service.SearchName(prefix).Value;
            return Json(users);
        }

        public IActionResult SearchName(string senderAccountId)
        {
            ViewBag.AccountId = senderAccountId;
            return View();
        }

        [HttpPost]
        public IActionResult SearchName(string receiverName, string receiverId, string senderAccountId)
        {
            ViewBag.SenderAccountId = senderAccountId;
            var receiver = service.GetReceiver(receiverId);
            return PartialView("_ReceiverPartial", receiver);
        }

        public IActionResult Create(string id)
        {

            return View();
        }

        [HttpPost]
        public async Task<IActionResult> Create(TransactionInputModel model)
        {
            
            var senderName = context.HttpContext.User.Identity.Name;

            if (!ModelState.IsValid)
            {
                return View(model);
            }

            await service.Create(model, senderName);

            return Redirect("/Account/All");
        }

        public async Task<IActionResult> All ()
        {
            var currUser = context.HttpContext.User.Identity.Name;

            var model = service.All(currUser);

            return View(model);
        }
    }
}

MyBankApp/Views/Shared/_CurrencyTablePartial.cshtml
@using MyBankApp.Core.ViewModels
@model CurrencyViewModel

@{
    var count = 1;
}

<table class="table">
    <thead class="thead-dark">
        <tr>
            <th scope="col">#</th>
            <th scope="col">Currency</th>
            <th scope="col">Price</th>
            <th scope="col">USD</th>
            <th></th>
        </tr>
    </thead>
    <tbody>
        @foreach (var curr in @Model.Rates)
        {
            <tr>
                <th scope="row">@(count++)</th>
                <td>@curr.Name</td>
                <td>@curr.Percent</td>
                <td>1</td>
                <td>
                    <a type="button" class="btn btn-success" 
                    asp-controller="Purchase" 
                    asp-action="SelectAccount"
                    asp-route-Name="@curr.Name"
                    asp-route-Price="@curr.Percent">Buy</a>
                </td>
            </tr>
        }
    </tbody>
</table>

MyBankApp/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - MyBankApp</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" asp-append-version="true" />
    <link rel="stylesheet" href="~/MyBankApp.styles.css" asp-append-version="true" />
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
            <div class="container-fluid">
                <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">MyBankApp</a>
                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex justify-content-between">
                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Index">Home</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
                        </li>
                    </ul>
                    <partial name="_LoginPartial" />
                </div>
            </div>
        </nav>
    </header>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2022 - MyBankApp - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @await RenderSectionAsync("Scripts", required: false)
</body>
</html>

MyBankApp/Views/Shared/_Layout3.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <title>The Right Way - Admin Template</title>

    <!-- META SECTION -->
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <link rel="shortcut icon" href="favicon.ico" type="image/x-icon">
    <link rel="icon" href="favicon.ico" type="image/x-icon">
    <!-- END META SECTION -->
    <!-- CSS INCLUDE -->
    <link rel="stylesheet" href="~/css/styles.css?v=1.0.3">
    <!-- EOF CSS INCLUDE -->
    @*<link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.rtl.css" />*@
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap-grid.min.css" />
    <link rel="stylesheet" href="~/css/site.css" asp-append-version="true" />
    @*<link rel="stylesheet" href="~/MyBankApp.styles.css" asp-append-version="true" />*@
    @*<script src="~/lib/jquery/dist/jquery.min.js"></script>*@

    <!-- JQuery links -->
    <script src="https://ajax.aspnetcdn.com/ajax/jQuery/jquery-1.10.0.min.js" asp-append-version="true"></script>
    <script src="https://ajax.aspnetcdn.com/ajax/jquery.ui/1.9.2/jquery-ui.min.js" asp-append-version="true"></script>
    <link rel="stylesheet" type="text/css" href="https://ajax.aspnetcdn.com/ajax/jquery.ui/1.9.2/themes/blitzer/jquery-ui.css"/>
    @*<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.js"></script>*@


</head>
<body class="indent indent--rounded indent--shadowed">

    <!-- PAGE WRAPPER -->
    <div class="page page--w-header page--w-container">

        <!-- PAGE HEADER -->
        <header class="page__header invert">
            <div class="logo-holder">
                <a href="/" class="logo-text d-none d-lg-block"><strong class="text-primary">#</strong> <strong>MyBankApp</strong></a>
                <a href="/" class="logo-text d-lg-none"><strong class="text-primary">#</strong><strong>MBA</strong></a>
            </div>

            <div class="col-sm-7 adminPage">
                @if (User.IsInRole("Administrator"))
                {
                    <a asp-area="Admin" asp-controller="Home" asp-action="Index">
                        <h2>Administrator page</h2>
                    </a>
                }
            </div>
            <div class="col-sm-3 box-fluid">

                @if (User.Identity.IsAuthenticated)
                {

                    <div>
                        Hello, @User.Identity.Name!
                    </div>
                }
            </div>

        </header>
        <!-- //END PAGE HEADER -->
        <!-- PAGE CONTAINER -->
        <div class="page__container invert">
            <nav class="horizontal-navigation">
                <button class="btn btn-light btn--icon" data-action="horizontal-show"><span class="fa fa-bars"></span> Toggle navigation</button>
                <ul>
                    <li class="title">Main</li>
                    <li class="openable" id="dashboard">
                        <a href="/Home/Index">
                            <span class="icon li-home"></span>
                            <span class="text">Home</span>
                        </a>
                    </li>
                    @if (!User.Identity.IsAuthenticated)
                    {

                        <li id="signin">
                            <a asp-area="Identity" asp-controller="Account" asp-action="Login">
                                <span class=""></span>
                                <span class="text">Sign in</span>
                            </a>
                        </li>
                        <li id="register">
                            <a asp-area="Identity" asp-controller="Account" asp-action="Register">
                                <span class="text">Register</span>
                            </a>
                        </li>
                    }
                    else
                    {
                        <li>
                            <a onclick=activateForm() asp-controller="Account" asp-action="All" method="Get">
                                
                                    <span class="text">My Accounts</span>
                                
                            </a>
                        </li>

                        <li>
                            <a asp-controller="Transaction" asp-action="All" method="Get">
                                
                                    <span class="text">Transactions</span>
                                
                            </a>
                        </li>

                          <li>
                            <a asp-controller="Purchase" asp-action="BoughtCurrencies" method="Get">
                                
                                    <span class="text">Currencies</span>
                            </a>
                        </li>
                        
                        <li id="logout">
                            <a>
                                <form class="form-inline" asp-area="Identity" asp-page="/Account/Logout" asp-route-returnUrl="@Url.Page("/", new { area = ""})" method="post">
                                    <button >
                                        <span class="text">Logout</span>
                                    </button>
                                </form>
                            </a>
                        </li>
                    }
                </ul>
            </nav>
        </div>
        <!-- //END PAGE CONTAINER -->
        <!-- PAGE CONTENT WRAPPER -->
        <div class="page__content" id="page-content">

            <!-- PAGE CONTENT CONTAINER -->
            <div class="content" id="content">

                <!-- PAGE HEADING -->
                <div class="renderbody">
                    @RenderBody()
                </div>
                <!-- //END PAGE HEADING -->

                <div class="container-fluid">
                    <div class="card margin-bottom-0">
                        <div class="card-body text-muted">
                            &copy; All rights reserved. The Right Admin - Responsive Admin Template @DateTime.Now.Year
                        </div>
                    </div>
                </div>
            </div>
            <!-- //END PAGE CONTENT CONTAINER -->

        </div>
        <!-- //END PAGE CONTENT -->

    </div>
    <!-- //END PAGE WRAPPER -->
    <!-- TEMPLATE SETTINGS -->
    <!-- //END TEMPLATE SETTINGS -->
    <!-- IMPORTANT SCRIPTS -->
    @*<script type="text/javascript" src="js/vendors/jquery/jquery.min.js"></script>
    <script type="text/javascript" src="js/vendors/jquery/jquery-migrate.min.js"></script>
    <script type="text/javascript" src="js/vendors/bootstrap/bootstrap.bundle.min.js"></script>*@

    @*<script type="text/javascript" src="js/vendors/mcustomscrollbar/jquery.mCustomScrollbar.concat.min.js"></script>*@
    <!-- END IMPORTANT SCRIPTS -->
    <!-- THIS PAGE SCRIPTS ONLY -->
    <!-- //END THIS PAGE SCRIPTS ONLY -->
    <!-- TEMPLATE SCRIPTS -->
  @*  <script type="text/javascript" src="js/app.js"></script>
    <script type="text/javascript" src="js/plugins.js"></script>
    <script type="text/javascript" src="js/demo.js"></script>
    <script type="text/javascript" src="js/settings.js"></script>*@
    <!-- END TEMPLATE SCRIPTS -->
    @*<script src="~/lib/jquery/dist/jquery.min.js"></script>*@
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @*@await RenderSectionAsync("Scripts", required: false)*@
   
</body>
</html>

MyBankApp/Views/Shared/_ReceiverPartial.cshtml
@model ShowReceiverViewModel

@{
    var count = 1;
    Layout = "_Layout3";
}

<div id="showReceiver">
    <h2>Iformation for: @Model.UserName</h2>

    <table class="table table-striped">
        <thead>
            <tr>
                <th scope="col">#</th>
                <th scope="col">Name</th>
                <th scope="col">Account</th>
                <th></th>
            </tr>
        </thead>
        <tbody>
            @foreach (var account in @Model.Accounts)
            {
                <tr>
                    <th scope="row">@(count++)</th>
                    <td>@account.NickName</td>
                    <td>@account.AccountNumber</td>
                    <td>
                        <a class="btn btn-outline-warning" 
                        asp-controller="Transaction" 
                        asp-action="Create" 
                        asp-route-id="@account.Id" 
                        asp-route-userId="@Model.Id" 
                        asp-route-senderAccountId="@ViewBag.SenderAccountId"
                        model="Get">Send money</a>
                    </td>
                </tr>
            }
        </tbody>
    </table>
</div>